import { Injectable } from '@nestjs/common';
import { BaseIndexManager } from 'src/core/modules/domain/usecase/managers/base-index.manager';
import { UserPrivilegeConfigurationEntity } from '../../../entities/user-privilege-configuration.entity';
import { SelectQueryBuilder } from 'typeorm';
import {
  Param,
  RelationParam,
} from 'src/core/modules/domain/entities/base-filter.entity';

@Injectable()
export class IndexUserPrivilegeConfigurationManager extends BaseIndexManager<UserPrivilegeConfigurationEntity> {
  async prepareData(): Promise<void> {
    return;
  }

  async beforeProcess(): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get relations(): RelationParam {
    return {
      joinRelations: [],
      selectRelations: [],
      countRelations: [],
    };
  }

  get selects(): string[] {
    return [];
  }

  get specificFilter(): Param[] {
    return;
  }

  setQueryFilter(
    queryBuilder: SelectQueryBuilder<UserPrivilegeConfigurationEntity>,
  ): SelectQueryBuilder<UserPrivilegeConfigurationEntity> {
    if (this.filterParam.user_privilege_ids) {
      queryBuilder.andWhere(`user_privilege_id In (:...privilegeIds)`, {
        privilegeIds: this.filterParam.user_privilege_ids,
      });
    }

    return queryBuilder;
  }
}
